
/*
 * Chiedere all'utente di inserire un dato numero N di interi positivi 
 * (controllando che N sia positivo e anche ogni dato in input) e 
 * determinare il massimo dei valori inseriti.
 * Variante con il calcolo anche del minimo e della media.
 * Inoltre indicare anche il numero di occorrenze del minimo e del massimo.
 * --> VARIANTE che NON utilizza la costante Integer.MAX_VALUE
 */

import java.util.*;
import java.text.*;

public class MassimoDiNEstesoVariante {
	public static void main(String[] args){
		
		Scanner tastiera = new Scanner(System.in);
		DecimalFormat df = new DecimalFormat("0.00");
		
		int n, valore; 
		int somma=0;
		int massimo=0, minimo=0, numMassimo=0, numMinimo=0; 
		
		System.out.println("Programma per il calcolo del massimo, del minimo e della media di n interi positivi.");
		System.out.println("Per i valori di massimo e minimo si riporta anche il numero di occorrenze.");
		do{
			System.out.print("Quanti valori vuoi inserire? ");
			n = tastiera.nextInt();
			if(n<=0)
				System.out.println("Il numero di valori da inserire deve essere positivo. Riprova.");
		}while(n<=0);
		for(int i=1; i<=n; i++){ 
			do{
				System.out.print("Inserire il valore "+ i +": ");
				valore = tastiera.nextInt();
				if(valore <= 0)
					System.out.println("Valore errato. Inserire un valore positivo.");
			}while(valore <= 0);
			somma += valore;
			if(i==1){ /* differenza di trattamento sul primo numero che viene considerato come prima
					occorrenza del minimo e come prima occorrenza del massimo */
				massimo = valore;
				numMassimo++;
				minimo = valore;
				numMinimo++;
			}
			else{
				if(valore == massimo)
					numMassimo++;
				if (valore == minimo)
					numMinimo++;
				if (valore > massimo){
					massimo = valore;
					numMassimo = 1;
				}
				else if (valore < minimo){ /* qui, volendo, si pu mettere else perch il primo numero  trattato 
								separatamente, quindi si sta trattando un numero successivo al primo
								inserito e non pu sussistere il caso di un numero contemporaneamente 
								> del massimo e < del minimo, come accade invece nella soluzione in
								MassimoDiNEsteso.java */
					minimo = valore;
					numMinimo = 1;
				}
			}
		}
		System.out.print("Il valore maggiore fra quelli inseriti e': "+massimo+" che compare "+numMassimo);
		if(numMassimo > 1)
			System.out.println(" volte.");
		else
			System.out.println(" volta.");
		System.out.print("Il valore minore fra quelli inseriti e': "+minimo+" che compare "+numMinimo);
		if(numMinimo > 1)
			System.out.println(" volte.");
		else
			System.out.println(" volta.");
		System.out.println("Il valore medio fra quelli inseriti e': "+df.format((double)somma/n));
		tastiera.close();
	}
}
